#!/usr/bin/perl -w

# Linux Application Checker
# Application Analysis Data Generator (analysis.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use strict;
use FindBin;
use File::Copy;

sub BEGIN { push @INC, $FindBin::Bin; }

use Analysis;

my ($lsb_version, $host_platform, $res_dir) = @ARGV;

my $data_dir = $FindBin::Bin;

my $name_l = $res_dir."/required_libs";

# Load distribution list (contains distribution name, version, database ID, architecture) 
Analysis::load_distrs($data_dir."/Distributions")
    or return "Failed to read the Distributions file.";

# First, check the cache files
my $libs_file      = $res_dir."/libs";
my $lib_attrs_file = $res_dir."/lib_attrs";
my $lib_kb_file    = $res_dir."/lib_kb";    

Analysis::load_libinfo($name_l, $data_dir, $host_platform);

Analysis::lib_dump($libs_file, $lib_attrs_file, $lib_kb_file);

copy("$data_dir/Distributions", $res_dir);

exit 0;