#!/usr/bin/perl -w

# Linux Application Checker
# Administration Page Module (tests_admin.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header('Linux Application Checker Administration', 'admin');

print "<h1>Linux Application Checker Administration</h1>\n";

print show_error_dlg('');

my $log_file = "$SERVER_PARAM{'APP_DATA'}/log/atk-server.log.$SERVER_PARAM{'PORT'}";
`head -n 1 $log_file 2>/dev/null` =~ m/PID: (\d+)\.$/i;
my $serv_pid = $1;

my $serv_status;
my $serv_stop_button;
if ($serv_pid) {
	$serv_status = "<font color=\"green\">Running</font> (PID: $serv_pid)";
	$serv_stop_button = " onclick=\"javascript:onStopServer($serv_pid, 'server');\"";
}
else {
	$serv_status = '<b><font color="red">PID not found!</font></b>';
	$serv_stop_button = ' disabled="disabled"';
}

print <<DATA;
<div id="ajax_loading" style="display: none; position: fixed; width: 13em; height: 5.8em; top: 40%; left: 50%; margin-top: -2.9em; margin-left: -7.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;"><div align="center">
Please, wait...<br />
<img src="images/environment-spacer.gif" width="1" height="5" alt="" /><br />
<img src="images/ajax_progress.gif" width="16" height="16" alt="" /><br />
<img src="images/environment-spacer.gif" width="1" height="7" alt="" /><br />
<input type="button" name="ajax_abort" id="ajax_abort" value="Abort" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 6em;" onclick="javascript:onAbort();" />
</div></div>

<div id="disable_layer" style="display: none; position: fixed; width: 100%; height: 100%; top: 0px; left: 0px; background-color: gray; opacity: 0.4; filter: alpha(opacity=40);"></div>

<table cellpadding="0" cellspacing="0" id="server_stopped" style="display: none; position: fixed; width: 25em; height: 6em; top: 40%; left: 50%; margin-top: -3em; margin-left: -12.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; vertical-align: middle; padding: 6px;"><tr><td>
<font size="+2" color="red"><b>Server is stopped</b></font>
</td></tr></table>

<table class="main" cellpadding="2" cellspacing="2">
  <tr>
    <td style="width: 8em;">Server status:</td>
    <td style="width: 12.5em;" id="server_status">$serv_status</td>
    <td><input type="button" id="server_stop" style="width: 7.5em;" value="Stop server"$serv_stop_button /></td>
  </tr>
</table>
<br />
<a href="/get.pl$log_file" target="_blank">View server log</a>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Preload some images that are not initially visible
preload_images(new Array('expand.png', 'collapse.png', 'ajax_progress.gif'));

// AJAX
function onStopServer(pid, what) {
	if (!ajax_req_busy) {
		if (confirm('Do you really want to kill the process tree (PID: ' + pid + ')?')) {
			ajax_call_get('action=stop_tests&tree=' + what);
		}
	}
}

function ajaxProcessResult(responseXML) {
	if (responseXML.getElementsByTagName('stopped').length > 0) {
		var stopped = responseXML.getElementsByTagName('stopped')[0].childNodes[0].nodeValue;
		var what = responseXML.getElementsByTagName('stopped')[0].getAttribute('id');
		var server_status = document.getElementById('server_status');
		var server_stop = document.getElementById('server_stop');
		if (server_status && server_stop) {
			server_status.innerHTML = '<font color="red">Not running</font>';
			server_stop.disabled = true;
			var server_stopped = document.getElementById('server_stopped');
			server_stopped.style.display = '';
			var show_disable_layer = true;
			if (navigator.appName == 'Konqueror') {
				show_disable_layer = false;
			}
			else if (navigator.appName == 'Microsoft Internet Explorer') {
				var idx = navigator.appVersion.indexOf('MSIE ');
				if (idx == -1) {
					show_disable_layer = false;
				}
				else {
					if (navigator.appVersion.substr(idx + 5, 1) < '7')
						show_disable_layer = false;
				}
			}
			if (show_disable_layer)
				document.getElementById('disable_layer').style.display = '';
		}
	}
}
// ]]>
</script>
DATA

print_footer();
