#!/usr/bin/perl -w

# Linux Application Checker
# Help Page Module (tests_help.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("Information", "help");

print <<DATA;
<a name="top"></a>
<p align="justify"><b>Linux Application Checker</b> provides a web interface for executing LSB tests.</p><br />
<table style="border: dashed 1px #2f6fab; padding: 5px; padding-right: 10px; white-space: nowrap; background-color: #f9f9f9;"><tr><td>
<h3>Help Contents</h3>
<ol>
  <li><a href="#conf">Application Check</a>
    <ul>
      <li><a href="#browse_component">Select Components pseudo-dialog</a></li>
    </ul>
  </li>
  <li><a href="#results">Result History page</a>
    <ul>
      <li><a href="#res-distrs">Distributions tab</a></li>
      <li><a href="#res-libs">Libraries tab</a></li>
      <li><a href="#res-ints">Interfaces tab</a></li>
      <li><a href="#res-cert">Certification tab</a></li>
      <li><a href="#upload">Upload page</a></li>
    </ul>
  </li>
  <li><a href="#help">Help page</a></li>
  <li><a href="#about">About page</a></li>
  <li><a href="#admin">Administration page</a></li>
  <li><a href="#troubleshooting">Troubleshooting</a></li>
</ol></td></tr>
</table>
<br />

<a name="conf"></a><h1>Application Check</h1>
<p align="justify">
This page allows you to configure the test system. The following options are present:
</p>
<ul>
<li><a name="app_name"></a><b>Application name:</b><br />Specify here name of the application you are going to test. It can be chosen arbitrarily and will only be used in reports, temporary file names, etc.</li>
<li><a name="file_formats"></a><b>Files and directories:</b><br />In this field you can specify files and directories that belong to the application. Any combination of the following is allowed:
  <ol>
    <li>ELF executables;</li>
    <li>ELF shared objects;</li>
    <li>Perl scripts;</li>
    <li>Python scripts;</li>
    <li>Shell scripts;</li>
    <li>directories with all contents;</li>
    <li>TAR.GZ packages;</li>
    <li>RPM packages.</li>
  </ol>
All the RPM and TAR.GZ packages will be unpacked, and their contents will be tested along with file explicitly specified. All files that are neither ELF files, nor scripts, and that are not specified explicitly (that is, from a directory or package contents) will be ignored when testing, so that the report would not be overflowed with errors about every such file.<br />
<b>Note:</b> If you wish to avoid typing long names by hand, use the <b>Select Files/Dirs&hellip;</b> button which opens the <a href="#browse_component"><b>Select Files/Dirs pseudo-dialog</b></a> for visually selecting the files and directories.</li>
<li><b>Installed packages:</b><br />Here you can specify RPM or DEB packages (depending on your system) that are already installed. Linux AppChecker will get the list of the files of the packages selected and test them as if they were specified explicitly. As above, all files that are neither ELF, nor scripts, will be ignored.<br />
<b>Note:</b> You can use the <b>Select Packages&hellip;</b> button to open the <a href="#browse_component"><b>Select Packages pseudo-dialog</b></a> where you can view all the packages installed and select them with checkboxes.</li>
<li><b>Architecture:</b><br />Allows to select the machine architecture. NOTE: Only architectures that are compatible with the machine being tested are listed.<br />
<i>Currently unsupported.</i></li>
<li><b>LSB Version:</b><br />This combobox specifies the LSB version to check against.</li>
<li><b>LSB Profile:</b><br />Allows to select the LSB profile to check against.</li>
<li><a name="comments"></a><b>Comments:</b><br />Here you may write comments with any additional information. These comments are stored in the execution report and shown on the <a href="#results"><b>Result History</b></a> page.</li>
</ul>
<p align="justify">
After you configured the settings you may press the button <b>Run the Test</b> located at the bottom of the page.<br />
You can quickly clear all the fileds by pressing the <b>Clear Form</b> button.
</p>

<a name="profile_management"></a><h3>User Profile Management</h3>
<p align="justify">
This section allows you to save/load all the settings listed above in different user profile files. To save the settings just specify the new profile name in the edit box (or use the drop-down list to select the existing profile and overwrite it), and then press the <b>Save</b> button. To load a previously saved profile, select it from the drop-down list and press <b>Load</b>. The <b>Delete</b> button allows you to delete the old profiles that are no longer needed.<br />
<b>Note:</b> The profile is not automatically saved when you run the tests! The settings are just stored in a temporary <i>session profile</i> which is automatically removed when it is no longer used. So if you wish to use the same set of options later, please save it explicitly, via the <b>Save</b> button.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="browse_component"></a><h2>Select Files/Dirs pseudo-dialog</h2>
<p align="justify">
This is a special page (pseudo-dialog) designed for easy selecting files and directories. The standard <b>Browse</b> dialog provided by the browser cannot be used for this purpose for the following reasons:
</p>
<ol>
  <li>This dialog shows the file system of the local machine, where the browser is opened. The Linux AppChecker can only test applications located on the same machine with itself; so if you are working with the Linux AppChecker remotely, the standard <b>Browse</b> will select wrong files (local instead of remote).</li>
  <li>This dialog does not allow selecting directories.</li>
  <li>Due to safety reasons, the standard Input File HTML control can be handled only manually, by the explicit user actions. Hence, it is not possible to restore its value when e.g. loading profiles.</li>
</ol>
<p align="justify">
The Browse pseudo-dialog contains two tabs:
</p>
<ol>
  <li>
    <b>Current directory</b><br />
    In this tab the following elements are shown:
    <ul>
      <li>Current path. You can click any part of it to jump quickly to the corresponding directory.</li>
      <li>The <b>Show Hidden</b> checkbox which allows you to show or hide files and directories starting with dot.</li>
      <li>List of files and subdirectories in the current directory. To open a subdirectory, just click the line with its name. For selecting files and directories to test, use checkboxes to the left from the name column. All selected files/directories on any depth level are automatically remembered and will not be lost as you navigate the file system.</li>
    </ul>
    In case you have selected earlier some item in the current directory which is not present in the file system at the moment, you will be warned and suggested to unselect the wrong items (you can ignore this warning and leave the selection if the missing file will be present by the moment the test starts, e.g. will be compiled from source).
  </li>
  <li>
    <b>All Selected</b><br />
    This tab contains all selected files and directories you have selected in one plain list, so that you can quickly view all the items together without necessity of going through all intermediate subdirectories, and/or unckeck the unneeded ones.
  </li>
</ol>
<p align="justify">
At the bottom of the dialog you can see the total number of the items currently selected (you can click this line for opening the <b>All Selected</b> tab), and the <b>Finish</b> button. Press this button to confirm your selection and close the dialog. To return without saving the selection, just close the dialog window in your browser as usual.
<p align="right"><a href="#top">Back to top</a></p>

<h2>Select Packages pseudo-dialog</h2>
<p align="justify">
This pseudo-dialog allows you to view and select the RPM or DEB packages installed in your system. For each package its name, version and release are shown (the latter is for RPMs only). You can select the packages using checkboxes on the left side and then press the <b>Finish</b> button to confirm selection. All the packages specified earlier in the <b>Installed packages</b> field are selected by default, so you don&lsquo;t need to reselect them. But if some of them cannot not be found, a warning is shown at the top of the page.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="results"></a><h1>Result History</h1>
<p align="justify">
This page shows the table with the full list of the tests execution results. The table contains the following columns:
</p>
<ul>
  <li><b>Date/Time</b><br />Here the date and time are shown, when the test was finished, as well as the name of the application tested. At the left edge of this column a status-icon is shown:
    <ul>
      <li><img src="images/TestsPassed.png" alt="Pass" width="33" height="30" /> The tests passed.</li>
      <li><img src="images/TestsFailed.png" alt="Fail" width="33" height="30" /> The tests failed.</li>
    </ul>
    In the cell&lsquo;s right-bottom corner there are several additional icons:
    <ul>
      <li><img src="images/report_details.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#res-cert"><b>Test Report</b></a> page for this test run (clicking the date/time link does the same).</li>
      <li><img src="images/report_summary.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#res-ints"><b>Application Analysis</b></a> page for this test run.</li>
      <li><img src="images/upload_data.png" alt="" width="16" height="16" /> This icon allows you to <a href="#upload"><b>upload</b></a> information about the application to the <a href="http://www.linuxfoundation.org/" target="_blank">Linux Foundation</a> for publishing in the Linux Applications section of the <a href="http://www.linuxfoundation.org/navigator/browse/app.php" target="_blank">LSB Navigator</a>. If you have already done it, the icon is not shown.</li>
    </ul>
  </li>
  <li><b>Summary</b><br />This column shows the general results of the tests (how many tests passed and failed).</li>
  <li><b>Comment</b><br />Here the comments entered on the <a href="#conf"><b>Application&nbsp;Check</b></a> page are shown.</li>
</ul>
<p align="justify">
To view the detailed particular report just click the link in the <b>Date/Time</b> field (see the <a href="#report"><b>Test Report page</b></a> section below for details).
</p>
<p align="justify">
To remove the reports that are no longer needed, just mark them with the checkboxes shown at the left edge of the corresponding lines and press the <b>Remove Selected Entries</b> button below the table.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="res-distrs"></a><h2>Distributions tab</h2>
<p align="justify">
Information about distributions.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="res-libs"></a><h2>Libraries tab</h2>
<p align="justify">
Information about libraries.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="res-ints"></a><h2>Interfaces tab</h2>
<p align="justify">
On this page you can see the list of the libraries and interfaces needed by the application.
</p>
<ul>
<li><b>List of Required Libraries</b><br />
The table contains the list of the external libraries that are required for the application to run. The following columns are shown:
  <ol>
    <li><b>Library</b><br />The so-called <i>soname</i> of the library (the real name in the file system).</li>
    <li><b>In LSB?</b><br />This flag shows whether the library is in LSB or not.</li>
    <li><b>Application Modules</b><br />The list of particular modules of the application tested that require the library.</li>
    <li><b>Comments</b><br />Here some additional information can be present about the library or how to eliminate the LSB inconsistency.</li>
  </ol>
</li>
<li><b>List of Required Interfaces</b><br />
In this table the external interfaces are listed that are required by the application to run. The following columns are shown:
  <ol>
    <li><b>Interface</b><br />The name of the interface. Please note that some names can be mangled.</li>
    <li><b>Library</b><br />Name of the library providing the interface.</li>
    <li><b>In LSB?</b><br />This flag shows whether the interface is in LSB or not.</li>
    <li><b>Application Modules</b><br />The list of particular modules of the application tested that require the interface.</li>
    <li><b>Comments</b><br />Here some additional information can be present about the interface or how to eliminate the LSB inconsistency.</li>
  </ol>
</li>
</ul>
<p align="justify">
Both tables have filters allowing to show only non-LSB entries (default), only LSB entries or both.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="res-cert"></a><h2>Certification tab</h2>
<p align="justify">
This page contains the detailed report about the test results. The section <b>Host Info</b> contains the information about the machine where the tests were executed. Below there is a combo-box allowing you to select grouping of test results:
</p>
<ul>
  <li><b>By Component</b><br />
  This is the selected by default. Below is shown the expandable tree with all the files tested and the number of passed and failed tests for each file. By clicking file name you can quickly go to the report for this particular file.<br />
  <a name="No_result"></a>If <b>No result</b> for some item is shown, this means that the test journal was not found. Usually the reason is that the test failed to run or was interrupted during the execution.<br />
  The <b>Detailed Reports by Components</b> section contains complete list of problems for each file tested and summary information (test statictics, tool used for testing this file, etc.). The table consists of the following columns:
    <ul>
      <li><b>Category</b><br />
      The problem category. It allows to understand quickly what was tested and why the test failed.
      </li>
      <li><b>Type</b><br />
      Severity of the problem. <a href="#severity">See below</a> for detailed explanation.
      </li>
      <li><b>Element</b><br />
      Specific element that caused the test to fail (e.g. library or interface name, ELF section, etc.).
      </li>
      <li><b>Comments</b><br />
      Additional comments that can be useful in eliminating the problem.
      </li>
    </ul>
    Pressing the plus sign in the most-left column expands the line and displays additional information, such as messages reported by the test in the journal file.
  </li>
  <li><b>By Category</b><br />
  All test results for all files are grouped by category. Below is shown the list of all categories with total number of fails for each category. Each category name is a link to the detailed list of problems in this category.
  The <b>Detailed Reports by Category</b> section contains for each category its short description and the complete list of problems in this category (for all components). The table consists of the same columns as above, except that the <b>Category</b> column is replaced with the <b>Component</b> column containing the path/name of the file tested.
  </li>
</ul>
<p align="justify">
<a name="severity"></a>For each test case its severity is shown. The most common are the following:
</p>
<ul>
  <li><b>Failed</b> means that a severe problem occured (it usually implies that the application is not LSB compliant).</li>
  <li><b>Warning</b> means that this some non-critical problem occured.</li>
  <li><a name="FIP"></a><b>FIP</b> stands for "<i>Futher Information Provided</i>". These FIP results occur when the test suite is unable to determine whether a result is a PASS or a FAIL. For LSB Certification you have to resolve each FIP case and upload your comments (in plain text) along with the test journals.</li>
  <li><b>Notice</b> appears for purely informative messages.</li>
  <li><b>Untested</b> is a status for test cases reporting that the test was not performed for some reason (e.g. not implemented yet).</li>
  <!--li><b>Quelled</b> means that the problem is waived and will not prevent the distro from being LSB certified.</li-->
</ul>
<p align="justify">
You can use the test report for applying for LSB certification. To begin with the certification process, just click the <b>apply for certification</b> link. You will be redirected to the <a href="http://$cert_sys_host$cert_sys_base" target="_blank">Certification System</a>. If necessary, you will be suggested to register, create your company and product you are going to certify.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="upload"></a><h2>Upload page</h2>
<p align="justify">
This page allows you to send the information about the application to the Linux Foundation so that it was added to the <a href="http://www.linuxfoundation.org/navigator/browse/app.php" target="_blank">LSB Navigator</a> (the Linux Applications section). The following fields are present:
</p>
<ul>
  <li><b>Contact name</b><br />Name of the person uploading the data.</li>
  <li><b>E-mail</b><br />Contact E-mail (it will be used for notification about adding the application to the LSB Navigator database).</li>
  <li><b>Application name</b><br />Name of the application. By default it contains the name specified on the <a href="#conf"><b>Application&nbsp;Check</b></a> page.</li>
  <li><b>Application version</b><br />Version of the application.</li>
  <li><b>Category</b><br />Here the category of the application is selected.</li>
  <li><b>User interface style</b><br />Specify if your application has graphical or console user interface.</li>
  <li><b>License type</b><br />Specify the license type your application is distributed under (Open Source or Proprietary).</li>
  <li><b>Application homepage</b><br />Homepage of the application (if any).</li>
  <li><b>Comments</b><br />If you have any comments, please write them here.</li>
</ul>
<p align="justify">
The mandatory fields are marked with red asterisks.
</p>
<p align="justify">
Below the form the link <b>View the file to be sent</b> is present. It allows you to check the contents of the file which is going to be uploaded to the Linux Foundation.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="help"></a><h1>Help</h1>
<p align="justify">
Contains the description of the web-interface of Linux Application Checker (the page you are reading now).
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="about"></a><h1>About</h1>
<p align="justify">
Contains the general information about LSB Application Testkit: its version, license, etc.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="admin"></a><h1>Administration</h1>
<p align="justify">
This page is designed for performing administrative tasks. Please be careful doing anything on this page!
</p>
<p align="justify">
Currently the following items are present:
</p>
<ul>
<li><b>Server status:</b><br />Shows current status of the web-server and its PID. The button <b>Stop server</b> shuts the server down. Please note that you will not be able to use the web interface after that!</li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="troubleshooting"></a><h1>Troubleshooting</h1>
<p align="justify">
Please, write to <a href="mailto:linux\@ispras.ru">linux\@ispras.ru</a> if you meet any troubles.
</p>
<p align="right"><a href="#top">Back to top</a></p>
DATA

print_footer();
